(cl:defpackage :std.io.stream
  (:use)
  (:local-nicknames (:% :std.internal)))
(cl:in-package :std.io.stream)

(%:var *stdin* cl:*standard-input*)
(%:var *stdout* cl:*standard-output*)
(%:var *stderr* cl:*error-output*)
(%:var *terminal-io* cl:*terminal-io*)
(%:var *trace-output* cl:*trace-output*)
(%:var *query-io* cl:*query-io*)
(%:var *debug-io* cl:*debug-io*)

(%:fn/macro ? (stream) cl:streamp)
;; added is- prefix here because otherwise these names could be confusing
(%:fn/macro is-input? (stream) cl:input-stream-p)
(%:fn/macro is-output? (stream) cl:output-stream-p)
(%:fn/macro is-interactive? (stream) cl:interactive-stream-p)
(%:fn/macro is-open? (stream) cl:open-stream-p)
(%:fn/macro element-type-in (stream) cl:stream-element-type)
(%:fn/macro element-type-out (stream) cl:stream-external-format)
;; TODO: there is also std.fs.file:stream-position as an alias to this
(%:fn/macro position (stream :optional (position 0)) cl:file-position)
(%:fn/macro byte-read! (stream :optional ((eof-error-p eof-error?) cl:t) eof-value) cl:read-byte)
(%:fn/macro byte-read-endian-little! ((s stream) :optional (bytes 4)) uiop/os:read-little-endian)
(%:fn/macro byte-write! (stream integer) cl:write-byte)
(%:fn/macro char-next (:optional peek-type (stream cl:*standard-input*) ((eof-error-p eof-error?) cl:t) eof-value ((recursive-p recursive?))) cl:peek-char)
(%:fn/macro char-next? (:optional (stream cl:*standard-input*)) cl:listen)
(%:fn/macro char-read! (:optional (stream cl:*standard-input*) ((eof-error-p eof-error?) cl:t) eof-value ((recursive-p recursive?))) cl:read-char)
(%:fn/macro char-read-nonblocking! (:optional (stream cl:*standard-input*) ((eof-error-p eof-error?) cl:t) eof-value ((recursive-p recursive?))) cl:read-char-no-hang)
(%:fn/macro char-read-undo! (character :optional (stream cl:*standard-input*)) cl:unread-char)
(%:fn/macro to-string (stream) cl:get-output-stream-string)
(%:fn/macro newline-ensure! (:optional (stream cl:*standard-output*)) cl:fresh-line)
(%:fn/macro newline-write! (:optional (stream cl:*standard-output*)) cl:terpri)
(%:fn/macro line-read! (:optional (stream cl:*standard-input*) ((eof-error-p eof-error?) cl:t) eof-value ((recursive-p recursive?))) cl:read-line)

;; NOTE:
;; very interesting, I'm getting a STYLE WARNING regarding both &optional and &key
;; ... except this is the actual argument list of cl:write-line ... terrific X)
;; (%:fn/macro line-write! (string :optional (stream cl:*standard-input*) :key (start 0) end) cl:write-line)
(%:fn line-write! cl:write-line)
(%:fn string-write! cl:write-string)

(%:fn/macro string-read-null-terminated! ((s octet-stream)) uiop/os:read-null-terminated-string)
(%:fn/macro sequence-read! (stream (seq sequence) :key (start 0) end) cl:read-sequence)
(%:fn/macro sequence-write! (stream (seq sequence) :key (start 0) end) cl:write-sequence)
;; NOTE: maybe instead of abort? name it force? or something
(%:fn/macro close! (stream :key ((abort abort?))) cl:close)
(%:fn/macro open! (filename :key (direction :input) (element-type 'cl:base-char) if-exists if-does-not-exist (external-format :default) (class 'sb-sys:fd-stream)) cl:open)
;; (%:macro open-do cl:with-open-stream)
(%:macro with-open cl:with-open-stream)
(%:fn/macro write-to-file (stream pathname :key (if-exists :error) if-does-not-exist) serapeum:write-stream-into-file)
(%:fn/macro input-discard (:optional (stream cl:*standard-input*)) cl:clear-input)
(%:fn/macro output-discard (:optional (stream cl:*standard-output*)) cl:clear-output)
;; (%:fn/macro user-decision (:optional (stream cl:*standard-output*)) cl:clear-output)
;; (%:fn/macro output-finish! (:optional (stream cl:*standard-output*)) cl:finish-output)
(%:fn/macro output-finish-abrupt! (:optional (stream cl:*standard-output*)) cl:finish-output)
(%:fn/macro output-finish-nonblocking! (:optional (stream cl:*standard-output*)) cl:force-output)
